library ieee;
use ieee.std_logic_1164.all;

library work;
use work.types.all;
use work.pcie.all;

package exzess_pcie_tlpgen_h is 
	component exzess_pcie_tlpgen is
		port (
			trn_i: in trn_i_type;
			trn_o: out trn_o_type;
			cfg_i: in cfg_i_type;
			cfg_o: out cfg_o_type;

			mem_rd_o: out mem_rd_o_type;
			mem_rd_rbar_hit_o: out std_logic_vector(6 downto 0);
			mem_rd_i: in mem_rd_i_type;

			mem_wr_o: out mem_wr_o_type;
			mem_wr_rbar_hit_o: out std_logic_vector(6 downto 0);
			mem_wr_i: in mem_wr_i_type;

			cpl_o: out cpl_o_type;
			cpl_i: in cpl_i_type;
			cpld_o: out cpld_o_type;
			cpld_i: in cpld_i_type;

			tx_mem_rd_i: in mem_rd_o_type; -- for the transmit direction, data type names are _reversed_
			tx_mem_rd_o: out mem_rd_i_type;

			tx_mem_wr_i: in mem_wr_o_type;
			tx_mem_wr_o: out mem_wr_i_type;

			tx_cpld_i: in cpld_o_type;
			tx_cpld_o: out cpld_i_type;

			diag_led: out std_logic;

			trn_clk: in std_logic;
			trn_reset_n: in std_logic--;
		);
	end component exzess_pcie_tlpgen;
end package exzess_pcie_tlpgen_h;
