library ieee;
use ieee.std_logic_1164.all;

-- wishbone connections
package wb is

type wb_master_o is record
	cyc: std_logic;
	stb: std_logic;
	we: std_logic;
	adr: std_logic_vector(31 downto 0);
	dat: std_logic_vector(31 downto 0);
	sel: std_logic_vector(3 downto 0);
end record wb_master_o;

type wb_slave_o is record
	ack: std_logic;
	err: std_logic;
	rty: std_logic;
	stall: std_logic;
	dat: std_logic_vector(31 downto 0);
end record wb_slave_o;

subtype wb_master_i is wb_slave_o;
subtype wb_slave_i is wb_master_o;

constant null_wb_master_o: wb_master_o := (adr => (others => '0'), dat => (others => '0'), sel => (others => '0'), others => '0');
constant null_wb_slave_o: wb_slave_o := (dat => (others => '0'), others => '0');
constant null_wb_master_i: wb_master_i := (dat => (others => '0'), others => '0');
constant null_wb_slave_i: wb_slave_i := (adr => (others => '0'), dat => (others => '0'), sel => (others => '0'), others => '0');

end package wb;
